// TrayIcon.h: interface for the CTrayIcon class.
//
//////////////////////////////////////////////////////////////////////

#pragma  once

#include "stdafx.h"
#include <ShellAPI.h>
#include <atlpath.h>
#include <vector>

struct TrayIconInfo
{
	UINT id;
	UINT time_interval;
};

class CTrayIcon  
{
public:
	CTrayIcon(HINSTANCE hInstance);
	CTrayIcon(HWND hWnd, UINT uCallbackMessage, LPCTSTR szTip, HICON icon, UINT uID, HINSTANCE hInstance);
	virtual ~CTrayIcon();

	//Create the tray icon
	int Create(HWND hWnd, UINT uCallbackMessage, LPCTSTR szTip, HICON icon, UINT uID);

	//Change or retrieve the Tooltip text
	BOOL    SetTooltipText(LPCTSTR pszTooltipText);
	BOOL    SetTooltipText(UINT nID);
	CString GetTooltipText();

	//Change or retrieve the icon displayed
	BOOL  SetIcon(HICON hIcon);
	BOOL  SetIcon(LPCTSTR lpIconName);
	BOOL  SetIcon(UINT nIDResource);
	BOOL  SetStandardIcon(LPCTSTR lpIconName);
	BOOL  SetStandardIcon(UINT nIDResource);
	HICON GetIcon() const;
	void  RemoveIcon();
	int   Animate(BOOL bInit = FALSE);
	void  PopupBalloon(BOOL bShow);

	//Change or retrieve the window to send notification messages to
	BOOL  SetNotificationWnd(HWND hWnd);
	HWND GetNotificationWnd() const;

	void AddIcon(UINT id, UINT interval) 
	{
		TrayIconInfo info;
		info.id = id;
		info.time_interval =  interval;
		m_IconList.push_back(info); 
	}

// Implementation
protected:
	int	   m_Animate_Number;
	NOTIFYICONDATA	m_tnd;
	HINSTANCE m_hInstance;
	std::vector<TrayIconInfo> m_IconList; 
	UINT m_intervalValue;
		 
};
